.autodepend

!include files.mak

ENGOBJ =  $(ENGSRC:.cpp=.obj)

SAOOBJ =  $(SAOSRC:.cpp=.obj)


CFLAGS = -O2 -I. -L. -w-8027
LIBS   = ./mml2mid.lib

UPX = upx
#UPX = rem
# upx͎st@Ckc[
# http://wildsau.idv.uni-linz.ac.at/mfx/upx.html
# QƂĂ

!ifdef SAORIVER
SAORIVER=-DSAORIVER="\"$(SAORIVER)\""
!endif



## TARGETS ##

ALLTARGET = ./saori_dll/mml2midwrap.dll

all : $(ALLTARGET)


./saori_dll/mml2midwrap.dll : ./saori_dll/saori.obj $(SAOOBJ) $(ENGOBJ)
	bcc32 -tWD -e$@ -lc $** $(LIBS)
	$(UPX) $@


.cpp.obj:
	bcc32 $(CFLAGS) $(SAORIVER) -n$: -c $<


clean :
	-for %f in ( $(ENGOBJ:/=\) $(SAOOBJ:/=\) ) do del %f
	-for %d in ( .\shiori_dll .\tool ) do del %d\*.tds
	-for %d in ( .\shiori_dll .\tool ) do del %d\*.obj

cleanall : clean
	-for %f in ( $(ALLTARGET:/=\) ) do del %f



