//---------------------------------------------------------------------------
//
// "mml2mid.dll" 경åѡ "MML2MIDwrap"
//
//      Programed by Sato.S (ȡ)
//
//  2002.10.15  Ver. 1.0.0    ɬפ˶Ʋ Phase 7.4.0
//
//---------------------------------------------------------------------------
#include <windows.h>
//---------------------------------------------------------------------------
#include "config.h"
//---------------------------------------------------------------------------
#include <string>
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <ctime>
#include <cctype>
#include <vector>
#include <io.h>
using namespace std;
//---------------------------------------------------------------------------
#include "engine/engine.h"
#include "misc/misc.h"
#include "misc/l10n.h"
#include "misc/mmap.h"
#include "misc/file.h"
//---------------------------------------------------------------------------
// SAORI/1.0 API
//---------------------------------------------------------------------------
// DLLɻ˸ƤФ
bool TNS_KawariANI::Load(const string& datapath)
{
	// ѥ¸
	DataPath=datapath;

	// Υߥ󥰤ޤ
	SRandom((int)time(NULL));

	// mml2mid.dllɤ߹
	string dllpath=DataPath+"mml2mid.dll";
	if((h = LoadLibrary(dllpath.c_str())) != NULL){
		Compile = (DWORD (WINAPI *)(LPSTR , LPSTR , DWORD , DWORD , LPSTR , DWORD))GetProcAddress(h,"Compile");
		pMsg=new char[8192];
	}

	return(true);
}
//---------------------------------------------------------------------------
// DLLɻ˸ƤФ
bool TNS_KawariANI::Unload(void)
{
	if(h!=NULL) {
		FreeLibrary(h);
		delete[] pMsg;
	}
	return(true);
}
//---------------------------------------------------------------------------
// AIꥯ
string TNS_KawariANI::Request(const string& type,TMMap<string,string>& request)
{
	map<string,string> response;
	unsigned int statuscode=400;

	string sender;
	if(request.count("Sender")) sender=request["Sender"];

    // SenderãϩʬΥ
	unsigned int sender_path;
	string sender_path_name="Unknown";
	if(request["SecurityLevel"]=="Local"){
		sender_path=SENDER_LOCAL;
		sender_path_name="Local";
	}else if(request["SecurityLevel"]=="External"){
		sender_path=SENDER_EXTERNAL;
		sender_path_name="External";
	}else{
		sender_path=SENDER_UNKNOWN;
		sender_path_name="Unknown";
	}

	if(SecurityLevel.Check(sender_path)) {
		if(type=="EXECUTE") {
			// EXECUTE
			if(request.count("Argument0")) {
				statuscode=Parse(request,response);
			}else{
				statuscode=400;
			}
		}else if(type=="GET Version") {
			// GET Version
			statuscode=200;
		}
	} else {
		// ¹ԵĤʤ
	}

	string statusheader;
	switch(statuscode) {
	case 200:
		statusheader="200 OK";
		break;
	case 204:
		statusheader="204 No Content";
		break;
	case 400:
		statusheader="400 Bad Request";
		break;
	default:
		statusheader="500 Internal Server Error";
		break;
	}

	string status="SAORI/"SAORIVER" "+statusheader+"\x0d\x0a";
	// Ĥʤ⡢responseˤCharsetղ
	// ȤꤢShift_JISȴ
	response["Charset"]="Shift_JIS";
	response["Sender"]=SAORI_NAME;

	map<string,string>::iterator it;
	for(it=response.begin();it!=response.end();it++) {
		if(it->second.size()) status=status+it->first+": "+it->second+"\x0d\x0a";
	}
	status+="\x0d\x0a";

	return(status);
}
//---------------------------------------------------------------------------
// ʲAPIʳ
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
TNS_KawariANI::TNS_KawariANI(void) : SecurityLevel(2)
{
	//
}
//---------------------------------------------------------------------------
TNS_KawariANI::~TNS_KawariANI(void)
{
	//
}
//---------------------------------------------------------------------------
// ꥯȤ˱ʸ
unsigned int TNS_KawariANI::Parse(TMMap<string,string>& request,map<string,string> &response)
{
	if(request["Argument0"]=="mml2mid") { // mml -> midiѴ
		// ե̵̾
		if(!request.count("Argument1")) {
			return 204;
		}
		// mmlե̾midե̾
		string mmlfile,midfile;
		mmlfile=DataPath+request["Argument1"];
		if(isexist(mmlfile)!=1) {
			return 204;
		}
		size_t periodpos=request["Argument1"].rfind('.');
		if(periodpos!=string::npos) {
			// ԥꥪɤä顢basenameСĥҤ.midפ
			midfile=DataPath+request["Argument1"].substr(0,periodpos)+".mid";
		}else{
			// ԥꥪɤĤʤΤǡʤĥҤäĤ
			midfile=DataPath+request["Argument1"]+".mid";
		}
		// mml2mid.dllƽʬ
		if(h!=NULL) {
			DWORD ret=1;
			char *mml,*mid;
			mml=(char *)mmlfile.c_str();
			mid=(char *)midfile.c_str();
			ret=(*Compile)(mml,mid,1,0,pMsg,8192);
			response["Result"]=IntToString(ret);
			return 200;
		}else{
			return 400;
		}
	}else if(request["Argument0"]=="rm") { // եõ
		int i=1;
		string path;
		while(request.count("Argument"+IntToString(i))!=0) {
			path=DataPath+request["Argument"+IntToString(i)];
			unlink(path.c_str());
			i++;
		}
		return 204;
	}else if(request["Argument0"]=="license") { // 饤ɽ
		ofstream ofs;
		string filename=DataPath+"mml2midwrap_license.txt";
		ofs.open(filename.c_str());
		if(!ofs.is_open()) {
			return 400;
		}
		ofs << SAORI_CORE_LICENSE;
		ofs.close();
		return 204;
	}else{ // ʳ
		return 400;
	}
}
//---------------------------------------------------------------------------

