include files.mak

.suffixes : .cpp .h

ENGOBJ =  $(ENGSRC:.cpp=.o)

SAOOBJ =  $(SAOSRC:.cpp=.o)


CFLAGS = -O2 -I.
LIBS   = 

UPX = upx
#UPX = rem
# upx͎st@Ckc[
# http://wildsau.idv.uni-linz.ac.at/mfx/upx.html
# QƂĂ


## TARGETS ##

ALLTARGET = ./saori_dll/mml2midwrap.dll

all : $(ALLTARGET)


./saori_dll/mml2midwrap.dll : ./saori_dll/saori.o $(SAOOBJ) $(ENGOBJ)
	dllwrap --driver-name g++ --def ./saori_dll/mingw_shiori.def -o$@ ./saori_dll/saori.o $(SAOOBJ) $(ENGOBJ) $(LIBS)
	strip $@
	$(UPX) $@


%.o : %.cpp
	g++ $(CFLAGS) $(SAORIVER) -o$@ -c $<


clean :
	-rm $(ENGOBJ) $(SAOOBJ)  ./saori_dll/saori.o

cleanall : clean
	-rm $(ALLTARGET)


depend : clean
	ruby ./makedepend.rb > depend.mak

#	ruby ./makedepend.rb --with-sjis2ascii > depend.mak


include depend.mak

