//---------------------------------------------------------------------------
//
// "mml2mid.dll" 경åѡ "MML2MIDwrap"
// file I/Oӥؿ
//
//      Original Programed by Kouji.U (sky)
//      Programed by Sato.S (ȡ)
//
//  2002.10.15  Ver. 1.0.0    ɬפ˶Ʋ Phase 7.4.0
//
//---------------------------------------------------------------------------
#include "config.h"
//---------------------------------------------------------------------------
#include "misc/file.h"
#include "misc/misc.h"
//---------------------------------------------------------------------------
#include <string>
#include <vector>
#include <fstream>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(_WIN32) && defined(NOHAVE_READDIR)
#	include "misc/_dirent.h"
#	define S_ISDIR(m) ((m&_S_IFDIR)!=0)
#	define S_ISREG(m) ((m&_S_IFREG)!=0)
#else
#	include <dirent.h>
#endif
using namespace std;
//---------------------------------------------------------------------------
string dirname(const string &path)
{
	return PathToBaseDir(path);
}
//---------------------------------------------------------------------------
string filename(const string &path)
{
	return PathToFileName(path);
}
//---------------------------------------------------------------------------
int isdir(const string &path)
{
	string dirname=path;
	struct stat buf;

	if(stat(dirname.c_str(),&buf)) return -1;

	if(S_ISDIR(buf.st_mode)) {
		return 1;
	}else{
		return 0;
	}
}
//---------------------------------------------------------------------------
int isfile(const string &path)
{
	string pathname=path;
	struct stat buf;

	if(stat(pathname.c_str(),&buf)) return -1;

	if(S_ISREG(buf.st_mode)) {
		return 1;
	}else{
		return 0;
	}
}
//---------------------------------------------------------------------------
int isexist(const string &path)
{
	string dirname=PathToBaseDir(path);
	string filename=PathToFileName(path);

	DIR *dirhandle;
	struct dirent *direntry;
	if((dirhandle=opendir(dirname.c_str()))==NULL) return -1;

	int ret=0;
	while((direntry=readdir(dirhandle))!=NULL) {
		string entry=direntry->d_name;
		if((entry!=".")&&(entry!="..")&&(entry==filename)) {
			ret=1;
			break;
		}
	}

	closedir(dirhandle);

	return ret;
}
//---------------------------------------------------------------------------
